#!/usr/bin/env python -u

from expression import *
from statement import *
from program import *

import c_code

import tpg
import sys
import os.path

def main():

    # Generate the parser.
    f = file(os.path.dirname(os.path.abspath(sys.argv[0])) + "/parser.g", "r")
    grammar = f.read()
    f.close()

    parser_code = tpg.translate(grammar)
 #   print parser_code
    exec(parser_code)

    parser = Parser()

#    f = file(sys.argv[1])
#    library = parser(f.read())
#    f.close()

    f = file(sys.argv[1])
    program = parser(f.read())
    f.close()

#    replacements = library.strip_replacements()
#    program.write(sys.stdout)

#    print "---> <---"

#    r = replacements[0]
#    program.replace(r)

#    program.write(sys.stdout)

    program.rts()

    out = sys.stdout
    if len(sys.argv) > 2:
        out = file(sys.argv[2], "w")
        
    c_code.emit(program, out)
    
if __name__ == "__main__":
    main()
    
